/*   ͻ
 *   	Program  : INTR.C						  
 *   	Revision : 1.0							  
 *   	Date	 : 11/10/90			    AXIOMTEK Tec. Co., Ltd.  
 *   Ķ
 *   	Purpose  : This demo program perform N channel A/D conversion with
 *   		   Interrupt by function INIT,SET_CH,SET_GAIN,SET_TIMER   
 *   		   INTR,READ_ST,DIS_INTR,TRAN_DAT.			  
 *   ͼ
 */


#include	"ax5210.h"
#include	<dos.h>
#include	<malloc.h>
#include	<fcntl.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<conio.h>
#define 	IOPORT		0x300  /* AX5210 Ioport  */
int far 	*intr_buf;
int far 	*ary1;
int far 	*ary2;
int		fun,flag;
unsigned int	dio[7];

main()
{

	int		start_ch, stop_ch;
	unsigned int	i, count=1024;

	 ary1=(int far *) _fmalloc(count * sizeof(int));
	 if (ary1 == NULL) {
	     printf("malloc ary1 error\n");
	     exit(1);
	 }
	 ary2=(int far *) _fmalloc(count * sizeof(int));
	 if (ary2 == NULL) {
	     printf("malloc ary2 error\n");
	     exit(1);
	 }

/* ķ
    INITIAL AX5210	
   Ľ */
	fun=INIT;		/* Initial function */
	dio[0]=IOPORT;		/* Ioport set */
	dio[1]=3;		/* IRQ NO. */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0) {
		printf (" DRIVER INITIALIZATION FAILED !,flag=%d\n",flag);
		exit(1);
	}

/* ķ
    SET START & STOP CHANNEL 
   Ľ */
	printf ("ENTER START CHANNEL NUMBER <S/E--0...15>");
	scanf ("%d",&start_ch);
	printf ("ENTER STOP  CHANNEL NUMBER <S/E--0...15>");
	scanf ("%d",&stop_ch);
	fun=SET_CH;		/* Set channel function */
	dio[0]=start_ch;	/* Start channel set */
	dio[1]=stop_ch; 	/* Stop  channel set */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag !=0 ) {
		printf ("SET SCAN CHANNEL FAILED ! RE-ENTER");
		exit(1);
	}

/* ķ
    SET GAIN FOR ALL CHANNEL 
   Ľ */
	for (i=0; i<16; i++) {
		fun=SET_GAIN;	/* Set gain function */
		dio[0]=i;	/* Set channel */
		dio[1]=1;	/* Set gain */
		flag=ax5210(fun,dio,ary1,ary2);
		if (flag != 0) {
			printf ("SET GAIN FAILED !,FLAG=%d\n",flag);
			exit(1);
		}
	}

/* ķ
     SET TIMER BEFORE INTERRUPT (MAX RATE=10k) 
   Ľ */
	fun=SET_TIMER;		 /* set timer rate = 1M/(divisor1 * divisor2) */
	dio[0]=10;		 /* divisor 1 */
	dio[1]=20;		 /* divisor 2 */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0) {
		printf ("Set Timer error ! flag=%d\n",flag);
		exit(1);
	}

/* ķ
    ENABLE INTERRUPT ACCORDING TO TIMER RATE 
   Ľ */
	fun=NADCG_INT;		/* Interrupt function */
	dio[0]=count;		/* Count */
	dio[1]=0x8000;		/* Memory segment */
	dio[2]=TIMER_TRG;	/* Pacer trigger */
	dio[3]=ONE_CYC; 	/* One cycle  */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0) {
		printf("Interrupt err NO=%d,count=%x\n",flag,dio[5]);
		exit(0);
	}

/* ķ
    READ INTERRUPT COUNT 
   Ľ */
	printf("PLEASE WAIT");
	do {
	    fun=READ_ST;		/* Read Interrupt count function */
	    flag=ax5210(fun,dio,ary1,ary2);
	} while (dio[1] != 0);

/* ķ
    DISABLE INTERRUPT 
   Ľ */
	fun=DIS_INTR;		 /* Disable interrupt  */
	flag=ax5210(fun,dio,ary1,ary2);
	if (flag != 0) {
		printf("Interrupt disbale err NO=%d\n",flag);
		exit(0);
	}

/* ķ
    TRANSFER DATA FROM MEMORY TO ARRAY 
   Ľ */
	fun=TRAN_DAT;
	dio[0]=count;
	dio[1]=0x8000;
	dio[2]=0;
	flag=ax5210(fun,dio,ary2,ary1);
	if (flag!=0 ) {
		printf ("data transfer error ! flag=%d\n",flag);
		exit(1);
	}

/* ķ
    DISPLAY CHANNEL & DATA 
   Ľ */
	intr_buf = (int far *) 0x80000000L;  /* pointer to raw data area */
	for (i=count-40;i<count;i++)
	     printf("\n raw data=%4x,ch=%5d, data=%5d",intr_buf[i],ary1[i],ary2[i]);

       _ffree(ary1);
       _ffree(ary2);
}
