{*   ͻ
 *   	Program  : INTR_G.PAS						  
 *   	Revision : 1.0							  
 *   	Date	 : 03/05/90			    AXIOMTEK Tec. Co., Ltd.  
 *   Ķ
 *   	Purpose  : This demo program perform N channel A/D conversion with
 *   		   Interrupt by function INIT,SET_CH,SET_GAIN,SET_TIMER   
 *   		   INTR,READ_ST,DIS_INTR,TRAN_DAT.			  
 *   ͼ
 *}

PROGRAM 	INTR_G;
USES		CRT;
{$L  AX5210P.OBJ}
{$I  AX5210.INC}
TYPE	X=ARRAY[1..10] OF INTEGER;
	Y=ARRAY[1..64] OF INTEGER;
VAR
	DIO: X;
	CH, DAT: Y;
	FLAG,FUN:INTEGER;
	START_CH, STOP_CH, I, COUNT:INTEGER;

FUNCTION	AX5210(FUN:INTEGER;VAR DIO:X):INTEGER;EXTERNAL;

BEGIN
	CLRSCR;
 { ķ
    INITIALIZE AX5210	
   Ľ }
	FUN := INIT;
	DIO[1] := $300;
	DIO[2] := 3;
	FLAG := AX5210(FUN,DIO);
	IF FLAG <> 0 THEN
	   BEGIN
	    WRITELN('AX5210 INITIALIZE ERROR FLAG = ',FLAG);
	    EXIT
	   END;

 { ķ
    SET START & STOP CHANNEL 
   Ľ }
	WRITE('ENTER START CHANNEL NUMBER <S/E--0...15>');
	READLN(start_ch);
	WRITE('ENTER STOP  CHANNEL NUMBER <S/E--0...15>');
	READLN(stop_ch);

	fun := SET_CH;		   { Set channel function   }
	dio[1] := start_ch;	   { Start channel set	    }
	dio[2] := stop_ch;	   { Stop  channel set	    }
	flag := ax5210(fun,dio);
	if (flag <> 0 ) THEN WRITELN('SET SCAN CHANNEL FAILED ! RE-ENTER');

 { ķ
    SET GAIN FOR ALL CHANNEL 
   Ľ }
	for i:=0 TO 15 DO
	    BEGIN
		fun := SET_GAIN;   { Set gain function	 }
		dio[1] := i;	   { Set channel	 }
		dio[2] := 1;	   { Set gain		 }
		flag := ax5210(fun,dio);
		if (flag <> 0) THEN WRITELN('SET GAIN FAIL')
	    END;
 { ķ
     SET TIMER BEFORE INTERRUPT (MAX RATE= 4k) 
   Ľ }
	fun := SET_TIMER;	{ set timer rate = 1M/(divisor1 * divisor2) }
	dio[1] := 40;		{ divisor 1 }
	dio[2] := 10;		{ divisor 2 }
	flag := ax5210(fun,dio);
	if (flag <> 0) THEN WRITELN('SET TIMER FAILED');

	WRITELN('under testing please wait');

 { ķ
    ENABLE INTERRUPT ACCORDING TO TIMER RATE 
   Ľ }
	COUNT := 64;
	fun := NADCG_INT;	{ Interrupt Group collection function }
	dio[1] := count;	{ Count 	     }
	dio[2] := $6000;	{ Memory segment     }
	dio[3] := TIMER_TRG;	{ Pacer trigger      }
	dio[4] := ONE_CYC;	{ One cycle	     }
	flag := ax5210(fun,dio);
	if (flag <> 0) THEN WRITELN('INTERRUPT FAILED');

 { ķ
    READ INTERRUPT COUNT 
   Ľ }
	REPEAT
	    fun := READ_ST;	 { Read Interrupt count function }
	    flag := ax5210(fun,dio);
	    gotoxy(50,1);
	    WRITELN('Intr count=', DIO[3]:5);
	UNTIL dio[2] = 0;	 { DIO[2] = 1 : ACTIVE }

 { ķ
    DISABLE INTERRUPT 
   Ľ }
	fun := DIS_INTR;	  { Disable interrupt  }
	flag := ax5210(fun,dio);
	if (flag <> 0) THEN WRITELN('DIABLE INTERRUPT FAILED');

 { ķ
    TRANSFER DATA FROM MEMORY TO ARRAY 
   Ľ }
	fun := TRAN_DAT;
	dio[1] := count;	  { TRANSFER NO.	    }
	dio[2] := $6000;	  { MEMORY SEGMENT	    }
	dio[3] := 0;		  { START CONVERSION NO.    }
	dio[4] := OFS(DAT);	  { OFFSET OF DATA ARRAY    }
	dio[5] := OFS(CH);	  { OFFSET OF CHANNEL ARRAY }
	flag := ax5210(fun,dio);
	if (flag <> 0 ) THEN WRITELN('DATA TRANSFER FAILED');

 { ķ
    DISPLAY CHANNEL & DATA 
   Ľ }
	for i := 1 TO COUNT DO
	    WRITELN(' CH= ', CH[I]:2, '  data= ', DAT[I]:5);
END.
